/* License: @%%Netbula RPC Time Limited Demo, Commercial Distribution Prohibited! */

#ifndef msg_h
#define msg_h

#ifdef __cplusplus
extern "C" {
#endif
#include <rpc/types.h>

/*redefine below to use different timeout*/
#ifndef PWRPC_TIMEOUT
#define PWRPC_TIMEOUT PWRPC_TIMEOUT_DEF
#endif

#ifndef _RPCAPI
#define _RPCAPI  /* wanna change this? */
#endif


#ifdef _RPC_SERVER
#define server_err(x) pwrpc_report_event(x)
#define server_msg(x) pwrpc_report_event(x)
#define server_exit(x) exit(x)
#endif

#undef _RPCAPI
#define _RPCAPI MSGSERVAPI
#define MSGSERVAPI __declspec(dllexport)
#define RPC_MT_CONNECT 1
#define RPC_RETURN_ARG 1
/******************************************
The two macros below show how to use fixed port
for server, and how to bypass portmapper
 registration
*******************************************/
#define MSGSERV_V1_tcp_server_port 2244


typedef int intarr[8];

#if !(defined(__cplusplus) || defined(__STDC__))
bool_t xdr_intarr();
#else
bool_t xdr_intarr(XDR*, intarr);
#endif



#define MSGSERV ((u_long)1234567)
#define MSGSERV_program ((u_long)1234567)
#define MSGSERV_V1 ((u_long)1)
#define MSGSERV_V1_version ((u_long)1)
#define sendmsg ((u_long)2)
#define sendmsg_proc ((u_long)2)
#if defined(RPC_CLIENT)
#if !defined(RPC_RETURN_ARG)
char **
sendmsg_1(char **inarg_ptr,  CLIENT *clnt);
#else
int sendmsg_1(char **inarg_ptr, char **result_ptr,  CLIENT *clnt);
#endif
#endif


#if !defined(RPC_CLIENT)
_RPCAPI extern char **
#if !(defined(__cplusplus) || defined(__STDC__))
sendmsg_1_svc(); /*service routine to be implemented*/
#else
sendmsg_1_svc(char **, struct svc_req *rqstp); /*Programmer implements this for server */
#endif
#endif
#define sendintegers ((u_long)3)
#define sendintegers_proc ((u_long)3)
#if defined(RPC_CLIENT)
#if !defined(RPC_RETURN_ARG)
int *
sendintegers_1(int *inarg_ptr,  CLIENT *clnt);
#else
int sendintegers_1(int *inarg_ptr, intarr result_ptr,  CLIENT *clnt);
#endif
#endif


#if !defined(RPC_CLIENT)
_RPCAPI extern int*
#if !(defined(__cplusplus) || defined(__STDC__))
sendintegers_1_svc(); /*service routine to be implemented*/
#else
sendintegers_1_svc(int *, struct svc_req *rqstp); /*Programmer implements this for server */
#endif
#endif
#define send_double ((u_long)4)
#define send_double_proc ((u_long)4)
#if defined(RPC_CLIENT)
#if !defined(RPC_RETURN_ARG)
int *
send_double_1(double *inarg_ptr,  CLIENT *clnt);
#else
int send_double_1(double *inarg_ptr, int *result_ptr,  CLIENT *clnt);
#endif
#endif


#if !defined(RPC_CLIENT)
_RPCAPI extern int*
#if !(defined(__cplusplus) || defined(__STDC__))
send_double_1_svc(); /*service routine to be implemented*/
#else
send_double_1_svc(double *, struct svc_req *rqstp); /*Programmer implements this for server */
#endif
#endif

#ifdef __cplusplus
};
#endif


#endif
