#include <stdio.h>
#include <rpc/rpc.h>

/* we must define RPC_CLIENT in the client */
#define RPC_CLIENT

#include "MyRPCService.hpp"

int main(int argc, char*argv[])
{
	
	int i=100, i2=0;
	aType atype;
	int result_code=0;

	CMyRPCService client("localhost", "udp");
	
	CLIENT* cl = client.getHandle();
	
	if (cl == NULL) {
		client.pcreateerror(argv[1]);
		exit (1);
	}

	result_code = client.function_foo_1(&i, &atype);

	if(result_code ==0) {
		printf("Got reply {%d, %f}\n", atype.i, atype.d);
	}else {
		client.perror("MyRPC");
	}

	if(0==(result_code = client.function_bar_1(&atype, &i2))) {
		printf ("Got reply %d\n", i2);
	}else {
		client.perror("MyRPC");
		
	}
	xdr_free((xdrproc_t)xdr_aType, (char*) &atype);
	client.destroy();

	return 0;
}


