// mfcqclnDlg.cpp : implementation file
//

#include "stdafx.h"
#include "mfcqcln.h"
#include "mfcqclnDlg.h"
#include <rpc/rpc.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMfcqclnDlg dialog

CMfcqclnDlg::CMfcqclnDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMfcqclnDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMfcqclnDlg)
	m_pe = _T("");
	m_vol = _T("");
	m_bid = _T("");
	m_tick = _T("");
	m_host = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMfcqclnDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMfcqclnDlg)
	DDX_Text(pDX, IDC_PE, m_pe);
	DDX_Text(pDX, IDC_VOL, m_vol);
	DDX_Text(pDX, IDC_BID, m_bid);
	DDX_Text(pDX, IDC_EDIT1, m_tick);
	DDX_Text(pDX, IDC_HOST, m_host);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMfcqclnDlg, CDialog)
	//{{AFX_MSG_MAP(CMfcqclnDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_GETQ, OnGetq)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMfcqclnDlg message handlers

BOOL CMfcqclnDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMfcqclnDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMfcqclnDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMfcqclnDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//copied from cln_main.c

#include <rpc/rpc.h>

extern "C" {
#include "quote.h"
};

extern "C" quoteRec* getq_wrap(char**tick, CLIENT*cl);


void CMfcqclnDlg::OnGetq() 
{
	// TODO: Add your control notification handler code here
	CLIENT *cl;

	struct stockOrder order;
	struct quoteRec *pq=0;
	char tick[12];
	char *pt = tick;
	
	cl = clnt_create((const char*)m_host, quote, quote_v1, "udp");
	
	if (cl == NULL) {
		AfxMessageBox(clnt_spcreateerror((char*)(const char*)m_host));
		switch(rpc_createerr.cf_stat){
		case RPC_PMAPFAILURE:
			AfxMessageBox("Pmap failure");
		}
		return;
	}

	
	UpdateData(TRUE);

    strcpy(tick, (const char*) m_tick);
	tick[7]='\0';

		/* Call rpc here */
	
	pq = get_quote_2(&pt, cl);

	m_bid.Format("%f", pq->bid);
	m_vol.Format("%d", pq->volume);
	if(pq->prof) {
		m_pe.Format("%f", pq->prof->pe);
	}else {
		m_pe="";
	}
	

	//Use explicit cast to coerce the C++ compiler to accept the args

	xdr_free((xdrproc_t)xdr_quoteRec, (char*) pq); /*pq->company_name is allocated by RPC */

	
	clnt_destroy(cl);
	UpdateData(FALSE);

	
}
