#include <stdio.h>
#include <rpc/rpc.h>
#include "quote.h"

main(argc, argv)
int argc;
char *argv[];
{
	CLIENT *cl;
	int i, val;
	struct stockOrder order;
	struct quoteRec *pq=0;
	char tick[12];
	char *pt = tick;
	
	cl = clnt_create("localhost", quote, quote_v1, "udp");
	
	if (cl == NULL) {
		clnt_pcreateerror(argv[1]);
		exit (1);
	}

	
	while(1) {
		printf("\nEnter ticker\n==>");
		scanf("%s", tick);
		tick[7]='\0';

		/* Call rpc here */
		pq = get_quote_2(&pt,cl); 

		printf("\nResult: company=%s bid=%4.2f ask=%4.2f vol=%d tr=%c\n",
		          pq->company_name, pq->bid, pq->ask, pq->volume, pq->trend);

		xdr_free(xdr_quoteRec, &pq); /*pq->company_name is allocated by RPC */

		strcpy(order.tick, tick);
		order.quantity = 100;
		order.trade_type='S';

        val = *trade_2(&order,cl); /* RPC */

		printf("Trade %d shares", val);
	}
	
	clnt_destroy(cl);
	return 0;
}


