// mfcrfileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "mfcrfile.h"
#include "mfcrfileDlg.h"

extern "C" {
#include "../rfile.h"
}

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMfcrfileDlg dialog

CMfcrfileDlg::CMfcrfileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMfcrfileDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMfcrfileDlg)
	m_dir = _T("");
	m_server = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMfcrfileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMfcrfileDlg)
	DDX_Control(pDX, IDC_DIR_LIST, m_dir_list);
	DDX_Text(pDX, IDC_DIR, m_dir);
	DDX_Text(pDX, IDC_EDIT1, m_server);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMfcrfileDlg, CDialog)
	//{{AFX_MSG_MAP(CMfcrfileDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LIST, OnList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMfcrfileDlg message handlers

BOOL CMfcrfileDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMfcrfileDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMfcrfileDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMfcrfileDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMfcrfileDlg::OnList() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (rfile_bind((const char*)m_server, 0, 0, 0) == 0) {
        AfxMessageBox("Fail to connect to server!\n");
        return;
	}
	
  
    void            free_entry(DENTRY * pentry);
    void            print_entry(FILE * fp, DENTRY * pdentry);
    DENTRY          direntry;
	int             ret;
    direntry.next = 0;

	ret = rchdir((char*)(const char*)m_dir);
	if(ret) {
		AfxMessageBox("server fail chdir to "+ m_dir);
		return;
	}

    ret= rlistdir((char*)(const char*)m_dir, &direntry);
	if(ret) {
		AfxMessageBox("Fail to retrive dir list for " + m_dir);
		return;
	}
	DENTRY * pe=&direntry;
	m_dir_list.ResetContent();
    while(pe) {
		m_dir_list.AddString(pe->name);
		pe = pe->next;
	}
    DENTRY_freeres(&direntry);
	
}


